/** GSWHTMLBareString.m - <title>GSWeb: Class GSWHTMLBareString</title>

   Copyright (C) 1999-2004 Free Software Foundation, Inc.
   
   Written by:	Manuel Guesdon <mguesdon@orange-concept.com>
   Date: 	Jan 1999
   
   $Revision: 20507 $
   $Date: 2004-12-31 08:33:16 -0600 (Fri, 31 Dec 2004) $

   This file is part of the GNUstep Web Library.
   
   <license>
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   </license>
**/

#include "config.h"

RCS_ID("$Id: GSWHTMLBareString.m 20507 2004-12-31 14:33:16Z mguesdon $")

#include "GSWeb.h"

//====================================================================
@implementation GSWHTMLBareString

//--------------------------------------------------------------------
-(id)init
{
  if ((self=[super init]))
    {
    };
  return self;
};

//--------------------------------------------------------------------
-(id)initWithString:(NSString*)aString
{
  if ((self=[self init]))
    {
      ASSIGN(_string,aString);
    };
  return self;
};

//--------------------------------------------------------------------
-(void)dealloc
{
  DESTROY(_string);
  [super dealloc];
}

//--------------------------------------------------------------------
-(NSString*)description
{
  return [NSString stringWithFormat:@"<%s %p - String:[%@]>",
                   object_get_class_name(self),
                   (void*)self,
                   _string];
};

//--------------------------------------------------------------------
-(NSString*)string
{
  return _string;
};

@end

//====================================================================
@implementation GSWHTMLBareString (GSWHTMLBareStringA)

//--------------------------------------------------------------------
-(void)appendToResponse:(GSWResponse*)aResponse
              inContext:(GSWContext*)aContext
{
  LOGObjectFnStart();
  NSDebugMLLog(@"gswdync",@"ET=%@ id=%@",[self class],GSWContext_elementID(aContext));
  GSWSaveAppendToResponseElementID(aContext);//Debug Only
  GSWResponse_appendContentString(aResponse,_string);
  NSDebugMLLog(@"gswdync",@"END ET=%@ id=%@",[self class],GSWContext_elementID(aContext));
  LOGObjectFnStop();
};

@end

//====================================================================
@implementation GSWHTMLBareString (GSWHTMLBareStringB)

//--------------------------------------------------------------------
+(id)elementWithString:(NSString*)aString
{
  return [[[GSWHTMLBareString alloc]initWithString:aString] autorelease];
};
@end
